//
//  MessageController.m
//  Tutorial1
//
//  Created by Martin Ott on 10/27/05.
//  Copyright 2005 TUM. All rights reserved.
//

#import "MessageController.h"
#import "MessageSubscriber.h"


@implementation MessageController

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    NSLog(@"applicationDidFinishLaunching");
    publisher = [MessagePublisher new];
}

- (void)createMessageSubscriber:(id)sender {
    int numberOfSubscribers = [publisher numberOfSubscribers];
    MessageSubscriber *subscriber = [MessageSubscriber new];
    [subscriber setName:[NSString stringWithFormat:@"%d", numberOfSubscribers + 1]];
    [publisher subscribe:subscriber];
    [subscriber release];
}

- (void)removeMessageSubscriber:(id)sender {
    MessageSubscriber *subscriber = [[publisher subscribers] lastObject];
    if (subscriber) {
        [publisher unsubscribe:subscriber];
    }
}

- (void)publishMessage:(id)sender {
    NSString *message = [messageField stringValue];
    [publisher publishMessage:message];
}

@end
